
; SIZEOF can also be used for (most) registers...

IF @ModeBits EQ 64
IF SIZEOF RBX NE 8
.ERR "RBX != 8"
ENDIF
ELSE
.ECHO "Not in 64-bit mode, so RBX not tested..."
ENDIF

IF SIZEOF BL NE 1
.ERR "BL != 1"
ELSEIF SIZEOF BX NE 2
.ERR "BX != 2"
ELSEIF SIZEOF EBX NE 4
.ERR "EBX != 4"
ELSEIF SIZEOF ST(1) NE 10
.ERR "ST(0) != 10"
ELSEIF SIZEOF ST1 NE 10
.ERR "ST(0) != 10"
ELSEIF SIZEOF MM0 NE 8
.ERR "MM0 != 8"
ELSEIF SIZEOF XMM0 NE 16
.ERR "XMM0 != 16"
ELSEIF SIZEOF CR0 NE 4
.ERR "CR0 != 4"
ELSEIF SIZEOF DR0 NE 4
.ERR "DR0 != 4"
ELSEIF SIZEOF TR0 NE 4
.ERR "TR0 != 4"
ELSE
.ECHO "Amazing, it actually works..."
ENDIF

@RegSize MACRO name:REQ
    LOCAL Size
    IF (OPATTR name) AND 30h ; register=10h; valid=20h -> 30h
        Size = SIZEOF name
    ELSE
        Size = -1
    ENDIF
    EXITM Size
ENDM

    .code

    mov eax,@RegSize(al)
    ret

    end
